Lua_SmallMenuWindow = class("Lua_SmallMenuWindow", Lua_Window);
function Lua_SmallMenuWindow:ctor()
    self:superCall("ctor");
    self.isClickClose = true;
    self.blackAlpha = 1 / 255;
    self.isModel = true;
    self.showClose = false;
    self.showBg = false;
    self.w = 2000;
    self.h = 2000;
    self.windowName = "Lua_SmallMenuWindow";
end
function Lua_SmallMenuWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.maskBg:setDepth(3500);
    self.downMenuBg = UICreate.createUIAtlasImage(self.content, "forgingWindow", "ronglian_downMenu", -90, 220, 212, 98);

    self.Arr = Array();
    self.Arr:add( { txt = LanUtil.getValue(107470) })
    self.Arr:add( { txt = LanUtil.getValue(107472) })
    if DataCenter.friendData:isMyFriend(DataCenter.hook.selectedId) then
        self.Arr:add( { txt = LanUtil.getValue(107599) })
    end
    self.Arr:add( { txt = LanUtil.getValue(107473) })
    self.Arr:add( { txt = LanUtil.getValue(107474) })
    self.Arr:add( { txt = LanUtil.getValue(107476) })
    self.menu_DragList = Lua_DragList.new(self.downMenuBg.mainContent, 1, Vector4(0, 0, 200, 85));
    self.menu_DragList:setLocation(2, -4, 0);
    self.menu_DragList:setListCell(MenuItem, 36, 100, 2);
    self.menu_DragList:setLuaArrayData(self.Arr, true);
end


function Lua_SmallMenuWindow:dispose()
    if self.menu_DragList ~= nil then
        self.menu_DragList:dispose();
        self.menu_DragList = nil;
    end
    self:superCall("dispose");
end

MenuItem = class("MenuItem", Lua_ListCell);
function MenuItem:ctor(p)
    self:superCall("ctor", p, "MenuItem_skin");
end
function MenuItem:buildShowItem()
    self:superCall("buildShowItem");
end

function MenuItem:setData(data)
    self._data = data
    self.tipsLbl.text = data.txt;
end

function MenuItem:onPlayerSoundClick(go)
    if self._data.txt == LanUtil.getValue(122003) then
        -- 交易
        Lua_ProxyManager.getProxy("Lua_TransProxy"):sTransMsg(DataCenter.hook.selectedId);
    elseif self._data.txt == LanUtil.getValue(107470) then
        -- 查看信息
        local cmd = ProtoPublic_pb.Proto10100156();
        cmd.role_id = DataCenter.hook.selectedId;
        sendMsg(10100156,cmd);
    elseif self._data.txt == LanUtil.getValue(107472) then
        -- 邀请入队
        local td = DataCenter.teamData;
        if td.hasTeam == false then
            OperateAlert.show(LanUtil.getValue(120224));
            return;
        end
        if td.isTeamFull == true then
            OperateAlert.show(LanUtil.getValue(122233));
            return;
        end
        local msg = getProtoMsg("Proto10100307");
        msg.role_id = DataCenter.hook.selectedId;
        sendMsg(10100307, msg);
    elseif self._data.txt == LanUtil.getValue(107599) then
        -- 私聊
    elseif self._data.txt == LanUtil.getValue(107473) then
        -- 添加好友
        local msg = getProtoMsg("Proto10100164");
        msg.friend_id = DataCenter.hook.selectedId;
        sendMsg(10100164, msg);
    elseif self._data.txt == LanUtil.getValue(107474) then
        -- 邀请入帮
        local leagueId = DataCenter.roleData.leagueId;
        local msg = getProtoMsg("Proto10100609");
        msg.league_index = leagueId;
        msg.invitee = DataCenter.hook.selectedId;
        sendMsg(10100609, msg);
    elseif self._data.txt == LanUtil.getValue(107476) then
        ----加入黑名单
        local tipData = { };
        local userInfo = DataCenter.thingData:getThing(DataCenter.hook.selectedId);
        tipData.des = LanUtil.formateStr(LanUtil.getValue(120112), string.format("[ff0000]%s[-]", userInfo.name));
        tipData.owner = self;
        tipData.type = 1;
        tipData.subFun = self.joinBlackDetermine;
        -- 确定
        self.tempData = self.params;
        -- tipData.cancelFun = self.onSubClick;  -- 取消
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    end
    Lua_WindowUtil.openWin("Lua_SmallMenuWindow", WinParam.ACTION_CLOSE);
end
function MenuItem:joinBlackDetermine(tipData)
    local msg = getProtoMsg("Proto10100158");
    msg.role_id = DataCenter.hook.selectedId;
    sendMsg(10100158, msg);
end
function MenuItem:dispose(go)
    self:superCall("dispose");
end
