﻿Lua_TransTipsWindow = class("Lua_TransTipsWindow", Lua_Window);
function Lua_TransTipsWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_TransTipsWindow";
    self.skinName = "TransTipsWindow_skin";
end

function Lua_TransTipsWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.subBtn:addClickFuntion(self, self.onSubClick);
    self.cancelBtn:addClickFuntion(self, self.onCancelClick);
    self.plus:addClickFuntion(self, self.onPlusClick);
    self.minus:addClickFuntion(self, self.onMinusClick)
    self.CountBar:setText("");
    self.count = 1;
    if self.itemImg == nil then
        self.itemImg = Lua_ToolImage.new(self.content);
        self.itemImg:setDepth(5);
        self.itemImg:setLocation(-85, 75, 0);
    end
    if self.numText == nil then
        self.numText = UICreate.createLabel(self.CountBar.mainContent, "", -113, 0, 40, 22, 20);
        self.numText.pivot = UIWidget.Pivot.Center;
        self.numText.overflowMethod = UILabel.Overflow.ResizeFreely;
        self.numText:setDepth(6)
    end
end
function Lua_TransTipsWindow:onPlusClick(args)
    self.count = self.count + 1
    if self.count >= self.offeetNum then
        self.count = self.offeetNum
    else
        self.count = self.count
    end
    self.CountBar:setValue(self.count);
    self:onUpDateTxt();
    --   self:slideingFun(self.count)
end
function Lua_TransTipsWindow:onMinusClick(args)
    self.count = self.count - 1
    if self.count <= 1 then
        self.count = self.count
    else
        self.count = self.count
    end
    self.CountBar:setValue(self.count);
    self:onUpDateTxt();
end
function Lua_TransTipsWindow:onSubClick(go)
    self:Submit();
    self:hide();
end
function Lua_TransTipsWindow:onCancelClick(go)
    self:Cancel();
    self:hide();
end
function Lua_TransTipsWindow:hide()
    self:superCall("hide");
end
function Lua_TransTipsWindow:Submit()
    if self.data ~= nil and self.data.subFun ~= nil then
        self.data.subFun(self.data.owner, self.count);
    end
end
function Lua_TransTipsWindow:Cancel()
    if self.data ~= nil and self.data.cancelFun ~= nil then
        self.data.cancelFun(self.data.owner, self.data);
    end
end
function Lua_TransTipsWindow:showWin(param)
    self.data = param;
    self.itemImg.data = param.imgData == nil and nil or param.imgData;
    self.itemNum = DataCenter.transData.voList[param.imgData.index] == nil and 0 or DataCenter.transData.voList[param.imgData.index];

    self.nameLbl.text = self.itemImg.data.colorName
    self.CountBar:createSlider("transWindow", "trans_thumb");
    self.offeetNum = self.itemImg.data.count - self.itemNum
    self.itemImg:showNum(self.offeetNum);
    self.CountBar:setMaxValue(self.offeetNum);
    self.CountBar:setValue(1);
    self.numText.text = "[ae6147]" .. 1;
    self.numText:setLocation(math.floor(-137 + 277 /(self.offeetNum) * 1), 0);
    self.CountBar:addSlideEndFun(self, self.slideEndFun);
    self.CountBar:addSlidingFun(self, self.slideingFun);
end

function Lua_TransTipsWindow:slideEndFun(val)
    if val < 1 then
        self.count = 1;
        self.CountBar:setValue(self.count);
    else
        self.count = val
    end
    self:onUpDateTxt();
end
function Lua_TransTipsWindow:slideingFun(val)
    if val < 1 then
        self.count = 1;
        self.CountBar:setValue(self.count);
    else
        self.count = val
    end
    self:onUpDateTxt();
end
function Lua_TransTipsWindow:onUpDateTxt()
    self.numText.text = "[ae6147]" .. self.count;
    self.numText:setLocation(math.floor(-137 + 277 /(self.offeetNum) * self.count), 0)
end
function Lua_TransTipsWindow:dispose()
    self:superCall("dispose");
end