﻿Lua_TransactionWindow = class("Lua_TransactionWindow", Lua_Window);
function Lua_TransactionWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_TransactionWindow";
    self.skinName = "Transaction_skin";
    self.showBg = false;
end
function Lua_TransactionWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.btnCloseR:addClickFuntion(self, self.hide);
    self.btnClose:addClickFuntion(self, self.hide);
    self.subBtn:addClickFuntion(self, self.onSubClick);
    self.suoBtn:addClickFuntion(self, self.onSuoClick);
    self.subBtn:setBtnEnable(false);

    self.islock = false;

    self:addLuaEvent("TRANS_UPDATE_DATA", self, self.onUpdateData)
    self:addLuaEvent("TRANS_TAKEIN", self, self.onTakeIn)
    self:addLuaEvent("TRANS_TAKEOUT", self, self.onTakeOut)
    self:addLuaEvent("TRANS_SUB_STATE", self, self.onTransSubEvent)
    self:addLuaEvent("TRANS_OTHER_TRANS", self, self.onTransOtherEvent)

    --  self:addLuaEvent("TRANS_LOCK_STATE", self, self.onSuoStateEvent)


    self.selfName.text = DataCenter.roleData.name;
    if DataCenter.transData.roleInviteName == nil then
        self.otherName.text = DataCenter.transData.roleName;
    else
        self.otherName.text = DataCenter.transData.roleInviteName;
    end

    self.othersArr = Array();

    self.others_draglist = Lua_DragList.new(self.content, 1, Vector4(-403, -239, 266, 370));
    self.others_draglist:setLocation(-33, 202, 0);
    self.others_draglist:setListCell(Lua_OTransGoodsItem, 95, 260, 1);


    self.selfArr = Array();
    self.self_draglist = Lua_DragList.new(self.content, 1, Vector4(-403, -239, 266, 370));
    self.self_draglist:setLocation(250, 202, 0);
    self.self_draglist:setListCell(Lua_STransGoodsItem, 95, 260, 1);

    self.packArr = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getBagAllData();

    self.pack_draglist = Lua_DragList.new(self.content, 1, Vector4(-376, -280, 428, 452));
    self.pack_draglist:setLocation(723, 255, 0);
    self.pack_draglist:setListCell(Lua_PackGoodsItem, 85, 85, 5);

    self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(self.packArr), false);
end

function Lua_TransactionWindow:minePackSellGoodsArr(arr)
    local len = arr:getSize();
    local num = 0;
    len = arr:getSize();
    if len < 25 then
        num = 25 - len;
    elseif len % 5 > 0 then
        num = 5 -(len % 5);
    end

    for i = 1, num do
        arr:add(i);
    end

    return arr;
end

function Lua_TransactionWindow:onSubClick()
    Lua_ProxyManager.getProxy("Lua_TransProxy"):sBeginTransMsg();
end
function Lua_TransactionWindow:onSuoClick()
    Lua_ProxyManager.getProxy("Lua_TransProxy"):sLockTransMsg();
end
function Lua_TransactionWindow:onUpdateData(data)
    self.data = data;
end
-- function Lua_TransactionWindow:onSuoStateEvent(val)
--    if val == true then
--        self.suoBtn:setText("取 消")
--    else
--        self.suoBtn:setText("锁 定")
--    end
-- end
function Lua_TransactionWindow:onTakeIn(data)
    if data == nil then
        return
    end

    self.selfArr = data;
    self.self_draglist:setLuaArrayData(self.selfArr, false);
    DataCenter.transData:initTransVo();
    for i = 1, self.selfArr:getSize() do
        DataCenter.transData:setTransData(self.selfArr[i].index, self.selfArr[i].count);
    end
    self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(self.packArr), false);
end
function Lua_TransactionWindow:onTakeOut(data)
    if data == nil then
        return
    end
    self.selfArr = data;
    DataCenter.transData:initTransVo();
    for i = 1, self.selfArr:getSize() do
        DataCenter.transData:setTransData(self.selfArr[i].index, self.selfArr[i].count);
    end
    self.self_draglist:setLuaArrayData(self.selfArr, false);
    self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(self.packArr), false);
end

function Lua_TransactionWindow:onTransOtherEvent(data)
    if data == nil then
        return
    end
    self.othersArr = data;
    self.others_draglist:setLuaArrayData(self.othersArr, false);
end

function Lua_TransactionWindow:onTransSubEvent(val)
    if val == true then
        self.subBtn:setBtnEnable(true);
    else
        self.subBtn:setBtnEnable(false);
    end
end

function Lua_TransactionWindow:hide()
    Lua_ProxyManager.getProxy("Lua_TransProxy"):sCloseTransMsg();
end
function Lua_TransactionWindow:dispose()
    if self.others_draglist ~= nil then
        self.others_draglist:dispose();
    end
    if self.self_draglist ~= nil then
        self.self_draglist:dispose();
    end
    if self.pack_draglist ~= nil then
        self.pack_draglist:dispose();
    end
    Lua_WindowUtil.openWin("Lua_TransTipsWindow", WinParam.ACTION_CLOSE, nil)
    self:superCall("dispose");
end


Lua_OTransGoodsItem = class("Lua_OTransGoodsItem", Lua_ListCell);
function Lua_OTransGoodsItem:ctor(p)
    self:superCall("ctor", p, "TransGoodsItem_skin");
end
function Lua_OTransGoodsItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(-85, 0, 0);
end

function Lua_OTransGoodsItem:setData(data)
    self.itemImg.data = nil;
    self._data = data
    self.itemImg.data = data;
    self.itemName.text = self.itemImg.data.colorName
    self.itemCount.text = LanUtil.formateStr(LanUtil.getValue(122000), tostring(self._data.count));
end

function Lua_OTransGoodsItem:onPlayerSoundClick(go)
end



Lua_STransGoodsItem = class("Lua_STransGoodsItem", Lua_ListCell);
function Lua_STransGoodsItem:ctor(p)
    self:superCall("ctor", p, "TransGoodsItem_skin");
end
function Lua_STransGoodsItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(-85, 0, 0);
end

function Lua_STransGoodsItem:setData(data)
    self.itemImg.data = nil;
    self._data = data
    self.itemImg.data = data;
    self.itemName.text = self.itemImg.data.colorName
    self.itemCount.text = LanUtil.formateStr(LanUtil.getValue(122000), tostring(self._data.count));
end

function Lua_STransGoodsItem:onPlayerSoundClick()
    Lua_MsgUtil.callFunc("TRANS_UPDATE_DATA", self._data);
    Lua_ProxyManager.getProxy("Lua_TransProxy"):sTakeOutTransMsg(self._data.id, self._data.index, self._data.count);
end




Lua_PackGoodsItem = class("Lua_PackGoodsItem", Lua_ListCell);
function Lua_PackGoodsItem:ctor(p)
    self:superCall("ctor", p);
end
function Lua_PackGoodsItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(0, 0, 0);
    self.itemImg:setCanClick(false);
end

function Lua_PackGoodsItem:setData(data)
    self._data = data;
    self.itemImg.data = nil;
    if type(self._data) == "number" then
        self.itemImg.data = nil;
    else
        self.itemImg.data = data;
        local num = DataCenter.transData.voList[self._data.index] == nil and 0 or DataCenter.transData.voList[self._data.index];
        if self._data.count - num <= 0 then
            self.itemImg.data = nil;
        else
            self.itemImg:showNum(self._data.count - num, false);
        end

        if data.bind == 1 then
            self.itemImg:setGray(true)
        else
            self.itemImg:setGray(false)
        end
    end

end

function Lua_PackGoodsItem:onPlayerSoundClick(go)
    Lua_MsgUtil.callFunc("TRANS_UPDATE_DATA", self._data);
    if type(self._data) ~= "number" and self.itemImg.data ~= nil then
        if self._data.bind ~= 1 then
            if self._data.count > 1 then
                local list = { };
                list.imgData = self._data;
                list.owner = self
                list.subFun = self.subClickEvent
                Lua_WindowUtil.openWin("Lua_TransTipsWindow", WinParam.ACTION_OPEN, list);
            else
                DataCenter.transData.Count = self._data.count
                Lua_ProxyManager.getProxy("Lua_TransProxy"):sPutIntoTransMsg(self._data.id, self._data.index, self._data.count);
            end
        else
            OperateAlert.show(LanUtil.getValue(122004));
        end
    end
end
function Lua_PackGoodsItem:subClickEvent(data)
    DataCenter.transData.Count = data;
    Lua_ProxyManager.getProxy("Lua_TransProxy"):sPutIntoTransMsg(self._data.id, self._data.index, DataCenter.transData.Count);
end